function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// 曲线， 基类
import { FACTOR } from "./config";
import { getDistance } from "./utils";

var Arc = /*#__PURE__*/function () {
  function Arc(options) {
    _classCallCheck(this, Arc);

    _defineProperty(this, "startX", void 0);

    _defineProperty(this, "startY", void 0);

    _defineProperty(this, "endX", void 0);

    _defineProperty(this, "endY", void 0);

    _defineProperty(this, "centerX", void 0);

    _defineProperty(this, "centerY", void 0);

    _defineProperty(this, "startAngle", void 0);

    _defineProperty(this, "endAngle", void 0);

    _defineProperty(this, "radius", void 0);

    _defineProperty(this, "color", void 0);

    _defineProperty(this, "lineWidth", 1);

    var startX = options.startX,
        startY = options.startY,
        endX = options.endX,
        endY = options.endY,
        width = options.width,
        _options$color = options.color,
        color = _options$color === void 0 ? '#fff' : _options$color; // 两点之间的圆有多个，通过两点及半径便可以定出两个圆，根据需要选取其中一个圆

    var l = getDistance(startX - endX, startY - endY);
    var m = (startX + endX) / 2; // 横轴中点

    var n = (startY + endY) / 2; // 纵轴中点

    var centerX = (startY - endY) * FACTOR + m;
    var centerY = (endX - startX) * FACTOR + n;
    var radius = getDistance(l / 2, l * FACTOR);
    var startAngle = Math.atan2(startY - centerY, startX - centerX);
    var endAngle = Math.atan2(endY - centerY, endX - centerX);
    this.startX = startX;
    this.startY = startY;
    this.endX = endX;
    this.endY = endY;
    this.centerX = centerX;
    this.centerY = centerY;
    this.startAngle = startAngle;
    this.endAngle = endAngle;
    this.radius = radius;
    this.color = color;
    this.lineWidth = width || 1;
  }

  _createClass(Arc, [{
    key: "draw",
    value: function draw(context) {}
  }]);

  return Arc;
}();

export default Arc;